<?php

//choose blog form
function bp_quickpress_switch_blog_form() {
		global $bp;
		global $blog_id;
		
		$form_action = $bp->loggedin_user->domain . $bp->blogs->slug . '/'.__('quickpress', 'bp-quickpress-slugs' ).'/switch-blog';
		$form_action = apply_filters('bp_quickpress_form_switchblog_url',$form_action);
?>
	<form id="bp_quickpress_blog_select" name="bp_quickpress_new_post" method="post" action="<?php echo $form_action; ?>">
		<p>
			<label for="blog"><?php _e('Blog');?></label><br/>
			<?php if ( bp_has_blogs(array('user_id'=>$bp->loggedin_user->id)) ) :
			if ($_GET['blog_id']) $blog_id = $_GET['blog_id'];
			?>
				<select name="blog_id" id="blog_id" onchange="this.form.submit()">
					<?php 
					while ( bp_blogs() ) : bp_the_blog();
						unset($selected);
						$thisblogid=bp_quickpress_blog_loop_id();
						if ($thisblogid==$blog_id) $selected=" SELECTED";
					echo'<option value="'.$thisblogid.'" '.$selected.'>'.bp_get_blog_title().'</option>';

					endwhile; ?>
				</select>
			<?php endif; ?>
		</p>
		<input type="hidden" name="action" value="quickpress-switch-blog"/>
	</form>
<?php
}

//creation post
function bp_quickpress_creation_form($form_action=false) {
	global $bp;
	
	bp_quickpress_switch_blog($_REQUEST['blog_id']);
	
	if (!bp_quickpress_user_can('edit_posts')) return false;
	
	if (!$form_action) {
		$form_action = $bp->loggedin_user->domain . $bp->blogs->slug . '/'.__('quickpress', 'bp-quickpress-slugs' ).'/'.__( 'save', 'bp-quickpress-slugs' );
		$form_action = apply_filters('bp_quickpress_form_creation_url',$form_action);
	}
?>

	<form id="bp_quickpress_new_post" name="bp_quickpress_new_post" method="post" action="<?php echo $form_action; ?>">
		<p>
			<label for="title"><?php _e('Title');?></label><br/>
			<input type="text" name="title" id="title"/>
		</p>
		<p>
			<label for="posttext"><?php _e('Description');?><small> - <em><?php _e('HTML allowed','bp-quickpress');?></em></small></label><br/>
			<textarea name="posttext" id="posttext" rows="3"></textarea>
		</p>
		<p>
			<label for="tags"><?php _e('Tags');?></label><br/>
			<input type="text" name="tags" id="tags"/>
		</p>
		<p>
			<label for="categories"><?php _e('Categories');?></label><br/>
			<?php bp_quickpress_categories();?>
		</p>
		<p>
			<?php wp_nonce_field( 'bp-quickpress-new-post' ); ?>
			<input type="hidden" name="action" value="quickpress-new"/>
			<?php
				if ($_REQUEST['blog_id'])
					echo'<input type="hidden" name="blog_id" value="'.$_REQUEST['blog_id'].'"/>';
			?>
			<input id="save" type="submit" value="<?php _e('Save');?>"/>
		</p>
	</form>

<?php
	bp_quickpress_switch_blog();
}

//edition post
function bp_quickpress_edition_form($form_action=false) {
	global $bp;
	global $blog_id;
	
	bp_quickpress_switch_blog($_REQUEST['blog_id']);

	
	if (!bp_quickpress_user_can('edit_posts')) return false;
	
	if (!$form_action) {
		$form_action = $bp->loggedin_user->domain . $bp->blogs->slug . '/'.__( 'quickpress', 'bp-quickpress-slugs' ).'/'.__( 'save', 'bp-quickpress-slugs' );
		$form_action = apply_filters('bp_quickpress_form_creation_url',$form_action);
	}
?>
	<form id="bp_quickpress_edit_post" name="bp_quickpress_edit_post" method="post" action="<?php echo $form_action; ?>">
		<p>
			<label for="blog_id"><?php _e('Blog');?></label><br/>
			<em>
			<?php
			
			if ($blog_id!=$_REQUEST['blog_id']) {
				$name = get_blog_option($_REQUEST['blog_id'],'blogname');
			}else {
				$name = get_blog_option($blog_id,'blogname');
			}
			echo $name;
			?>
			</em>
		</h3>
		</p>
		<p>
		<label for="title"><?php _e('Title');?></label><br/>
		<input type="text" name="title" id="title" value="<?php the_title(); ?>"/>
		</p>
		<p>
		<label for="posttext"><?php _e('Description');?><small> - <em><?php _e('HTML allowed','bp-quickpress');?></em></small></label><br/>
		<textarea name="posttext" id="posttext" rows="3"><?php echo esc_html(get_the_content()); ?></textarea>
		</p>
		<p>
		<label for="tags"><?php _e('Tags');?></label><br/>
		<?php
		$tags = get_the_tags();
		if ($tags) {
			foreach($tags as $tag) {
				$taglist[]=$tag->name;
			}
			$tags_str = implode(',',$taglist);
		}
		?>
		<input type="text" name="tags" id="tags" value="<?php echo $tags_str;?>"/>
		</p>
		<p>
			<label for="categories"><?php _e('Categories');?></label><br/>
			<?php bp_quickpress_categories();?>
		</p>
		<p>
			<?php wp_nonce_field( 'bp-quickpress-new-post' ); ?>
			<input type="hidden" name="post_id" value="<?php the_ID(); ?>"/>
			<input type="hidden" name="action" value="quickpress-new"/>
			<?php
				if ($_REQUEST['blog_id'])
					echo'<input type="hidden" name="blog_id" value="'.$_REQUEST['blog_id'].'"/>';
			?>
			<?php
		if (!bp_quickpress_user_can('publish_posts')) {
			$submit_text = __('Submit for Review');
		}else {
			$submit_text = __('Publish');
		}
		?>
			<input id="publish" type="submit" value="<?php echo $submit_text;?>"/>
		</p>
	</form>
<?php

	bp_quickpress_switch_blog();

}


//CATEGORIES

//display categories
function bp_quickpress_categories() {

	$array_categories = bp_quickpress_get_categories($_REQUEST['blog_id']);

	$treeset = new TreeSet();
	
	$categories_tree = $treeset -> drawTree($treeset -> buildTree($array_categories),'bp_quickpress_format_category');
	
	$output.='<div id="categories">';
	$output.=$categories_tree;
	$output.='</div>';

	echo $output;
}

//get blog categories (default=false=current blog)
function bp_quickpress_get_categories($blog=false,$parent=false,$categories=true) {
	global $wpdb, $bp,$blog_id;
	
	if (!$categories) return false;
	
	if ($blog) $blog_id = $blog;
	
	$table_prefix = $wpdb->base_prefix .$blog_id.'_';

	$table_terms = $table_prefix.'terms';
	$table_term_taxonomy = $table_prefix.'term_taxonomy';
	
	if ($parent)
		$more_parent = 'tt.parent='.$parent.' AND ';
	
	$children = $wpdb->prepare("SELECT t.term_id as ID,t.name,t.slug,tt.description,tt.parent,tt.count FROM {$table_terms} t"
	." LEFT JOIN {$table_term_taxonomy} tt ON t.term_id = tt.term_id"
	." WHERE {$more_parent} tt.taxonomy='category' ORDER BY t.name ASC");

	return $wpdb->get_results( $children );
}

//format category item
function bp_quickpress_format_category($cat) {
	global $post;
	
	$post_cats = wp_get_post_categories($post->ID);

	
	if ( (is_array($post_cats))&&in_array($cat->ID,$post_cats)) {
		$checked=' CHECKED';
	}elseif (($cat->ID==1) && (empty($post_cats))){ //default
		$checked=' CHECKED';
	}

	$html='<li class="category" id="cat-'.$cat->ID.'"><div class="folder icon"></div><input type="checkbox" name="categories[]" value="'.$cat->ID.'"'.$checked.'> <span class="text">'.$cat->name.'</span>';
	
	return $html;
}

?>